# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from qb_device_msgs/ConnectionState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import qb_device_msgs.msg

class ConnectionState(genpy.Message):
  _md5sum = "3fb8aec8a16b727f8528545cb7e04895"
  _type = "qb_device_msgs/ConnectionState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Device-independent connection state message

qb_device_msgs/DeviceConnectionInfo[] devices
================================================================================
MSG: qb_device_msgs/DeviceConnectionInfo
# Device-independent message that constains: 

int32 id           # device id;
bool is_active     # motor activation status;
string port        # serial port"""
  __slots__ = ['devices']
  _slot_types = ['qb_device_msgs/DeviceConnectionInfo[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       devices

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ConnectionState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.devices is None:
        self.devices = []
    else:
      self.devices = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.devices)
      buff.write(_struct_I.pack(length))
      for val1 in self.devices:
        _x = val1
        buff.write(_get_struct_iB().pack(_x.id, _x.is_active))
        _x = val1.port
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.devices is None:
        self.devices = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.devices = []
      for i in range(0, length):
        val1 = qb_device_msgs.msg.DeviceConnectionInfo()
        _x = val1
        start = end
        end += 5
        (_x.id, _x.is_active,) = _get_struct_iB().unpack(str[start:end])
        val1.is_active = bool(val1.is_active)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.port = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.port = str[start:end]
        self.devices.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.devices)
      buff.write(_struct_I.pack(length))
      for val1 in self.devices:
        _x = val1
        buff.write(_get_struct_iB().pack(_x.id, _x.is_active))
        _x = val1.port
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.devices is None:
        self.devices = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.devices = []
      for i in range(0, length):
        val1 = qb_device_msgs.msg.DeviceConnectionInfo()
        _x = val1
        start = end
        end += 5
        (_x.id, _x.is_active,) = _get_struct_iB().unpack(str[start:end])
        val1.is_active = bool(val1.is_active)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.port = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.port = str[start:end]
        self.devices.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_iB = None
def _get_struct_iB():
    global _struct_iB
    if _struct_iB is None:
        _struct_iB = struct.Struct("<iB")
    return _struct_iB
